\ This file Copyright 1988 by Warren Block.

\ serialwords.f

DECIMAL

CREATE SerPortName  0," serial.device"

1200 CONSTANT DefaultBaud

VARIABLE ReadMessage      \ for I/O with the serial port
VARIABLE WriteMessage
VARIABLE ReadPort
VARIABLE WritePort

256 CONSTANT ReadBufferSize

GLOBAL   ReadBuffer
VARIABLE WriteBuffer

CREATE ReadPortName   0," colorterm.read"
CREATE WritePortName  0," colorterm.write"

: CheckIO   ( ioRequest --- flag )  \ Check if I/O has completed.
   !A1 EXEC@ 78 ;

: AbortIO   ( ioRequest --- )  \ Abort an I/O operation.
   !A1 EXEC 80 ;

: SetSerialParams   ( baud --- )  \ Set baud rate, etc., for serial device.
                   ReadMessage @ +ioesBaud     !
   SERF_XDISABLED SERF_SHARED | ReadMessage @ +ioesSerFlags C!
   1024            ReadMessage @ +ioesRBufLen  !
   8               ReadMessage @ +ioesReadLen  C!
   8               ReadMessage @ +ioesWriteLen C!
   1               ReadMessage @ +ioesCtlChar  !    \ 0x11130501
   1               ReadMessage @ +ioesStopBits C!
   SDCMD_SETPARAMS ReadMessage @ +ioCommand    W!
   ReadMessage @ DoIO  DROP
   CMD_READ        ReadMessage @ +ioCommand    W! ;

: OpenSerialPort   ( --- )  \ Create ports and set up I/O messages.
   ReadBufferSize MEMF_PUBLIC MEMF_CLEAR | AllocMem  TO ReadBuffer
   ReadPortName 0 CreatePort         ReadPort    !
   ReadPort  @ IOExtSer CreateExtIO  ReadMessage !
   SERF_XDISABLED SERF_SHARED | ReadMessage @ +ioesSerFlags C!
   SerPortName 0 ReadMessage @ 0 OpenDevice  DROP
   CMD_READ   ReadMessage @ +ioCommand W!
   1          ReadMessage @ +ioLength  !
   ReadBuffer ReadMessage @ +ioData    !
   WritePortName 0 CreatePort        WritePort    !
   WritePort @ IOExtSer CreateExtIO  WriteMessage !
   SERF_XDISABLED SERF_SHARED | WriteMessage @ +ioesSerFlags C!
   SerPortName 0 WriteMessage @ 0 OpenDevice DROP         \ open a write port
   DefaultBaud SetSerialParams
   ReadMessage @ BeginIO ;

: CloseSerialPort   ( --- )  \ Close down I/O ports and messages.
   ReadMessage  @ CloseDevice
   ReadMessage  @ DeleteExtIO
   ReadPort     @ DeletePort
   WriteMessage @ CloseDevice
   WriteMessage @ DeleteExtIO
   WritePort    @ DeletePort
   ReadBuffer ReadBufferSize FreeMem ;

: EmitSerChar   ( char --- )  \ Send a character out the serial port.
   WriteBuffer C!
   CMD_WRITE   WriteMessage @ +ioCommand W!
   WriteBuffer WriteMessage @ +ioData    !
   1           WriteMessage @ +ioLength  !
   WriteMessage @ DoIO  DROP ;
